## cantata 1.4.2.ds1

=== CMakeLists.txt ===
PROJECT(cantata)

cmake_minimum_required(VERSION 2.6)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_GENERATOR "DEB;RPM;TBZ2")
set(DEBIAN_PACKAGE_DESCRIPTION "Qt/KDE Client for MPD")
set(DEBIAN_PACKAGE_SECTION "kde4")
set(CPACK_SOURCE_GENERATOR "TBZ2")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "4")
set(CPACK_PACKAGE_VERSION_PATCH "2")
set(CPACK_PACKAGE_VERSION_SPIN "")
set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
set(CANTATA_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
set(CANTATA_VERSION_FULL "${CANTATA_VERSION}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_FULL}${CPACK_PACKAGE_VERSION_SPIN}")
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_FULL}${CPACK_PACKAGE_VERSION_SPIN}")
set(CPACK_SOURCE_IGNORE_FILES  "/.svn/;CMakeLists.txt.user")
include(CPack)
include(MacroLogFeature)

option(ENABLE_TAGLIB "Enable TagLib library (required for tag editing, replaygain calculation, device support, etc)" ON)
option(ENABLE_TAGLIB_EXTRAS "Enable TagLib-Extras library (used by tag editing, replaygain calculation, device support, etc)" ON)
option(ENABLE_HTTP_STREAM_PLAYBACK "Enable playback of MPD HTTP streams (Phonon required for Qt4, QtMultimedia for Qt5)" OFF)
option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" OFF)
option(ENABLE_KDE "Enable KDE libraries" OFF)
option(ENABLE_KWALLET "Use KWallet in KDE builds" ON)
option(ENABLE_QT5 "Build against Qt5" OFF)
option(ENABLE_UBUNTU "Build for the Ubuntu SDK" OFF)
option(ENABLE_FFMPEG "Enable ffmpeg/libav libraries (required for replaygain calculation)" ON)
option(ENABLE_MPG123 "Enable mpg123 libraries (required for replaygain calculation)" ON)
option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" OFF)
option(ENABLE_EXTERNAL_TAGS "Enable usage of external app for reading/writing tags" ON)
option(ENABLE_HTTP_SERVER "Enable internal HTTP server to play non-MPD files" ON)
option(ENABLE_DYNAMIC "Enable support for dynamic playlists" ON)
option(ENABLE_STREAMS "Enable support for streams tab (to save favourite streams, and search for others)" ON)
option(ENABLE_ONLINE_SERVICES "Enable support for online services (Jamendo, Magnatune, SoundCloud, and Podcasts)" ON)
if (WIN32 OR APPLE)
    set(USE_SYSTEM_MENU_ICON OFF)
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
else (WIN32 OR APPLE)
    option(USE_SYSTEM_MENU_ICON "Use system menu icon" ON)
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
endif (WIN32 OR APPLE)
option(ENABLE_CDPARANOIA "Enable CDParanoia libraries (required for AudioCD support)" ON)
option(ENABLE_CDDB "Enable CDDB libraries (either this or MusicBrianz required for AudioCD support)" ON)
option(ENABLE_MUSICBRAINZ "Enable MusicBrianz libraries (either this or CDDB required for AudioCD support)" ON)
option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks, for Qt builds" OFF)
option(ENABLE_REMOTE_DEVICES "Enable support for remote (sshfs, samba) devices (EXPERIMENTAL)" OFF)
option(ENABLE_MTP "Enable MTP library (required to support MTP devices)" ON)
option(ENABLE_UNCACHED_MTP "Open MTP devices in un-cached mode (faster)" ON)

if (WIN32)
    set(CANTATA_ICON_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/icons/oxygen)
elseif (APPLE)
    set(MACOSX_BUNDLE_BUNDLE_NAME Cantata)
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CANATA_VERSION})
    set(MACOSX_BUNDLE_VERSION ${CANATA_VERSION})
    set(MACOSX_BUNDLE_LONG_VERSION_STRING ${CANTATA_VERSION_FULL})
    set(MACOSX_BUNDLE_ICON_FILE "cantata.icns")
    set(MACOSX_BUNDLE_RESOURCES "${CMAKE_INSTALL_PREFIX}/cantata.app/Contents/Resources")
    set(CANTATA_ICON_INSTALL_PREFIX ${MACOSX_BUNDLE_RESOURCES}/icons/oxygen)
else (WIN32)
    set(CANTATA_ICON_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor)
endif (WIN32)

if (ENABLE_UBUNTU)
    set(ENABLE_QT5 ON)
    set(ENABLE_DYNAMIC OFF)
    set(ENABLE_STREAMS OFF)
    set(ENABLE_ONLINE_SERVICES OFF)
    set(ENABLE_TAGLIB OFF)
    set(ENABLE_TAGLIB_EXTRAS OFF)
    set(ENABLE_FFMPEG OFF)
    set(ENABLE_MPG123 OFF)
    set(ENABLE_EXTERNAL_TAGS OFF)
    set(ENABLE_HTTP_SERVER OFF)
    set(ENABLE_CDPARANOIA OFF)
    set(ENABLE_CDDB OFF)
    set(ENABLE_MUSICBRAINZ OFF)
    set(ENABLE_UDISKS2 OFF)
    set(ENABLE_DEVICES_SUPPORT OFF)
    set(ENABLE_REMOTE_DEVICES OFF)
    set(ENABLE_MTP OFF)
    set(ENABLE_UNCACHED_MTP OFF)
    set(USE_SYSTEM_MENU_ICON OFF)
endif (ENABLE_UBUNTU)

if (ENABLE_QT5)
    set(ENABLE_KDE OFF)
endif (ENABLE_QT5)

if (NOT ENABLE_KDE)
   set(ENABLE_KWALLET OFF)
endif (NOT ENABLE_KDE)

if (NOT WIN32 AND NOT APPLE AND ENABLE_DEVICES_SUPPORT AND ENABLE_UDISKS2)
    set(WITH_SOLID_UDISKS2 ON)
endif (NOT WIN32 AND NOT APPLE AND ENABLE_DEVICES_SUPPORT AND ENABLE_UDISKS2)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message("-- Set build type to ${CMAKE_BUILD_TYPE}")
endif (NOT CMAKE_BUILD_TYPE)

if (ENABLE_UBUNTU)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/click")
elseif (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    if (ENABLE_KDE)
        find_program(KDE4_KDECONFIG_EXECUTABLE NAMES kde4-config
                     PATHS ${CMAKE_INSTALL_PREFIX}/bin ${_KDEDIRS} /opt/kde4/bin NO_DEFAULT_PATH)
        if (NOT KDE4_KDECONFIG_EXECUTABLE)
           find_program(KDE4_KDECONFIG_EXECUTABLE NAMES kde4-config )
        endif (NOT KDE4_KDECONFIG_EXECUTABLE)
        if (KDE4_KDECONFIG_EXECUTABLE)
            exec_program(${KDE4_KDECONFIG_EXECUTABLE} ARGS --prefix OUTPUT_VARIABLE CMAKE_INSTALL_PREFIX)
            message("-- Set install prefix to ${CMAKE_INSTALL_PREFIX}")
        endif (KDE4_KDECONFIG_EXECUTABLE)
    elseif (NOT APPLE AND NOT WIN32)
        set(CMAKE_INSTALL_PREFIX "/usr")
        message("-- Set install prefix to ${CMAKE_INSTALL_PREFIX}")
    endif (ENABLE_KDE)
endif (ENABLE_UBUNTU)

if (NOT ENABLE_QT5 AND NOT APPLE AND NOT WIN32)
    find_package(X11)
    if (X11_FOUND)
        include_directories(${X11_INCLUDE_DIR})
        set(CANTATA_LIBS ${CANTATA_LIBS} ${X11_LIBRARIES})
    endif (X11_FOUND)
endif (NOT ENABLE_QT5 AND NOT APPLE AND NOT WIN32)

if (ENABLE_TAGLIB)
    set(TAGLIB_MIN_VERSION "1.6")
    find_package(Taglib)
    macro_log_feature(TAGLIB_FOUND "TagLib" "Tag editor, file organiser, etc." "http://taglib.github.io/")
endif (ENABLE_TAGLIB)

if (TAGLIB_FOUND)
    if (ENABLE_DEVICES_SUPPORT AND ENABLE_CDPARANOIA)
        find_package(Cdparanoia)
        macro_log_feature(CDPARANOIA_FOUND "libcdda_paranoia" "CD ripping." "http://www.xiph.org/paranoia")
        if (CDPARANOIA_FOUND)
            if (ENABLE_CDDB)
                find_package(CDDB)
                macro_log_feature(CDDB_FOUND "libcddb" "CD info retrieval via CDDB." "http://libcddb.sourceforge.net")
            endif (ENABLE_CDDB)
            if (ENABLE_MUSICBRAINZ)
                find_package(MusicBrainz5)
                macro_log_feature(MUSICBRAINZ5_FOUND "libmusicbrainz5" "CD info retrieval via MusicBrainz." "http://musicbrainz.org/doc/libmusicbrainz")
            endif (ENABLE_MUSICBRAINZ)
        endif (CDPARANOIA_FOUND)
    endif (ENABLE_DEVICES_SUPPORT AND ENABLE_CDPARANOIA)

    set(ENABLE_TAGEDITOR_SUPPORT 1)
    set(ENABLE_TRACKORGANIZER_SUPPORT 1)
    include(CheckCXXSourceCompiles)
    set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
    set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")

    check_cxx_source_compiles("#include <asftag.h>
                            int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
    if (NOT TAGLIB_ASF_FOUND)
        message("TagLib does not have ASF support compiled in.")
    endif (NOT TAGLIB_ASF_FOUND)

    check_cxx_source_compiles("#include <mp4tag.h>
                            int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
    if (NOT TAGLIB_MP4_FOUND)
        message("TagLib does not have MP4 support compiled in.")
    endif (NOT TAGLIB_MP4_FOUND)

    set(CMAKE_REQUIRED_INCLUDES)
    set(CMAKE_REQUIRED_LIBRARIES)

    set(TAGLIB-EXTRAS_MIN_VERSION "1.0")
    if (ENABLE_TAGLIB_EXTRAS)
        find_package(Taglib-Extras)
        macro_log_feature(TAGLIB-EXTRAS_FOUND "TagLib-Extras" "Tag editor, file organiser, etc." "http://taglib.github.io/")
    endif (ENABLE_TAGLIB_EXTRAS)
    set(TAGLIB_EXTRAS_FOUND ${TAGLIB-EXTRAS_FOUND}) # we need a c-compatible name for the include file

    include(CheckTagLibFileName)
    check_taglib_filename(COMPLEX_TAGLIB_FILENAME)

    add_definitions(${TAGLIB_CFLAGS})
    if (TAGLIB-EXTRAS_FOUND)
        include_directories(${TAGLIB-EXTRAS_INCLUDES})
        add_definitions(${TAGLIB-EXTRAS_CFLAGS})
    endif (TAGLIB-EXTRAS_FOUND)

    if (ENABLE_FFMPEG)
        find_package(FFMPEG)
        macro_log_feature(FFMPEG_FOUND "libavcodec" "ReplayGain calculation." "http://ffmpeg.org")
    endif (ENABLE_FFMPEG)
    if (ENABLE_MPG123)
        find_package(MPG123)
        macro_log_feature(MPG123_FOUND "libmpg123" "ReplayGain calculation." "http://www.mpg123.de")
    endif (ENABLE_MPG123)
    if (ENABLE_MTP AND ENABLE_DEVICES_SUPPORT AND NOT WIN32 AND NOT APPLE)
        find_package(Mtp)
        macro_log_feature(MTP_FOUND "libmtp" "MTP Device Support." "http://libmtp.sourceforge.net")
    endif (ENABLE_MTP AND ENABLE_DEVICES_SUPPORT AND NOT WIN32 AND NOT APPLE)
else (TAGLIB_FOUND)
   set(ENABLE_DEVICES_SUPPORT OFF)
   set(ENABLE_EXTERNAL_TAGS OFF)
endif (TAGLIB_FOUND)

if (NOT MTP_FOUND)
   set(ENABLE_UNCACHED_MTP OFF)
endif (NOT MTP_FOUND)

if (ENABLE_QT5)
    find_package(Qt5Widgets REQUIRED)
    find_package(Qt5Xml REQUIRED)
    find_package(Qt5Network REQUIRED)
    find_package(Qt5Concurrent REQUIRED)
    find_package(Qt5Svg REQUIRED) # Only actually required for SVG icons...
    set(QTCORELIBS ${Qt5Core_LIBRARIES})
    set(QTNETWORKLIBS ${Qt5Network_LIBRARIES})
    set(QTGUILIBS ${Qt5Gui_LIBRARIES})
    set(QTLIBS ${QTCORELIBS} ${Qt5Widgets_LIBRARIES} ${QTNETWORKLIBS} ${QTGUILIBS} ${Qt5Xml_LIBRARIES} ${Qt5Concurrent_LIBRARIES})
    set(QTINCLUDES ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Concurrent_INCLUDE_DIRS})
    add_definitions(${Qt5Widgets_DEFINITIONS} ${Qt5Network_DEFINITIONS} ${Qt5Xml_DEFINITIONS} ${Qt5Concurrent_DEFINITIONS})
    set(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
    if (NOT ENABLE_UBUNTU)
        # Does Ubuntu/Touch version need DBus?
        find_package(Qt5DBus)
        macro_log_feature(Qt5DBus_FOUND "Qt5DBus" "DBus support." "http://qtproject.org")
            if (Qt5DBus_FOUND)
            set(QT_QTDBUS_FOUND 1) # required for config.h !!!
            set(QTLIBS ${QTLIBS} ${Qt5DBus_LIBRARIES})
            set(QTINCLUDES ${QTINCLUDES} ${Qt5DBus_INCLUDE_DIRS})
            add_definitions(${Qt5DBus_DEFINITIONS})
        endif (Qt5DBus_FOUND)
    endif (NOT ENABLE_UBUNTU)
    if (ENABLE_UBUNTU)
        find_package(Qt5Quick REQUIRED)
        find_package(Qt5Qml REQUIRED)
    endif (ENABLE_UBUNTU)
else (ENABLE_QT5)
    find_package(Qt4 REQUIRED QtCore QtGui QtXml QtNetwork QtSvg)  # SVG only actually required for SVG icons...
    set(QTCORELIBS ${QT_QTCORE_LIBRARY})
    set(QTNETWORKLIBS ${QT_QTNETWORK_LIBRARY})
    set(QTGUILIBS ${QT_QTGUI_LIBRARY})
    set(QTLIBS ${QT_QTXML_LIBRARY} ${QTCORELIBS} ${QTGUILIBS} ${QTNETWORKLIBS})
    if (QT_QTDBUS_FOUND)
        set(QTLIBS ${QTLIBS} ${QT_QTDBUS_LIBRARY})
    endif (QT_QTDBUS_FOUND)
    set(QTINCLUDES ${QT_INCLUDES})
    add_definitions(-DQT_NO_STL -DQT_NO_CAST_TO_ASCII -Wall -Wextra)
endif (ENABLE_QT5)

if (ENABLE_HTTP_STREAM_PLAYBACK)
    if (ENABLE_LIBVLC)
        find_package(LIBVLC REQUIRED)
        macro_log_feature(Qt5Multimedia "libVLC" "MPD HTTP stream playback." "http://videolan.org")
        add_definitions(-DLIBVLC_FOUND)

=== icons/CMakeLists.txt ===
if (NOT WIN32 AND NOT APPLE)
    macro (update_iconcache ICON_THEME)
        # Update mtime of hicolor icon theme dir.
        # We don't always have touch command (e.g. on Windows), so instead create
        #  and delete a temporary file in the theme dir.
        install(CODE "
        set(DESTDIR_VALUE \"\$ENV{DESTDIR}\")
        if (NOT DESTDIR_VALUE)
            file(WRITE \"${CMAKE_INSTALL_PREFIX}/share/icons/${ICON_THEME}/temp.txt\" \"update\")
            file(REMOVE \"${CMAKE_INSTALL_PREFIX}/share/icons/${ICON_THEME}/temp.txt\")
        endif (NOT DESTDIR_VALUE)
        ")
    endmacro (update_iconcache)
endif (NOT WIN32 AND NOT APPLE)

install(FILES cantata.svg DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/scalable/apps)
install(FILES cantata16.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/16x16/apps RENAME cantata.png)
install(FILES cantata22.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/22x22/apps RENAME cantata.png)
install(FILES cantata24.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/24x24/apps RENAME cantata.png)
install(FILES cantata32.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/32x32/apps RENAME cantata.png)
install(FILES cantata48.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/48x48/apps RENAME cantata.png)
install(FILES cantata64.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/64x64/apps RENAME cantata.png)

if (NOT WIN32 AND NOT APPLE)
    update_iconcache(hicolor)

    if (EXISTS /etc/lsb-release)
        file(READ "/etc/lsb-release" LSB_RELEASE_CONTENTS)
        string(REGEX MATCH "DISTRIB_ID=Ubuntu" IS_UBUNTU ${LSB_RELEASE_CONTENTS})
        if (IS_UBUNTU)
            set(INSTALL_UBUNTU_ICONS_DEFAULT ON)
        else(IS_UBUNTU)
            set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
        endif(IS_UBUNTU)
    else(EXISTS /etc/lsb-release)
        set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
    endif(EXISTS /etc/lsb-release)
    option(INSTALL_UBUNTU_ICONS "Install the Ubuntu themed monochrome panel icons" ${INSTALL_UBUNTU_ICONS_DEFAULT})

    if (INSTALL_UBUNTU_ICONS)
        install(FILES trayicon-mono-dark.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/ubuntu-mono-light/apps/22 RENAME cantata-panel.svg)
        install(FILES trayicon-mono-light.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/ubuntu-mono-dark/apps/22 RENAME cantata-panel.svg)
        update_iconcache(ubuntu-mono-light)
        update_iconcache(ubuntu-mono-dark)
    endif (INSTALL_UBUNTU_ICONS)

endif (NOT WIN32 AND NOT APPLE)

=== mac/CMakeLists.txt ===
install(FILES ${MACOSX_BUNDLE_ICON_FILE} DESTINATION ${MACOSX_BUNDLE_RESOURCES})

if (CANTATA_OXYGEN_DIR)
    add_subdirectory(icons)
endif (CANTATA_OXYGEN_DIR)

=== replaygain/CMakeLists.txt ===
if (FFMPEG_FOUND OR MPG123_FOUND)
    include_directories(${QTINCLUDES} ${ZLIB_INCLUDE_DIRS})
    if (FFMPEG_FOUND)
        set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} ffmpeginput.cpp)
        include_directories(${FFMPEG_INCLUDE_DIRS})
    endif (FFMPEG_FOUND)
    if (MPG123_FOUND)
        set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} mpg123input.cpp)
        include_directories(${MPG123_INCLUDE_DIRS})
    endif (MPG123_FOUND)

    set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} main.cpp replaygain.cpp trackscanner.cpp jobcontroller.cpp ../support/thread.cpp)
    set(CANTATA_RG_MOC_HDRS ${CANTATA_RG_MOC_HDRS} replaygain.h trackscanner.h jobcontroller.h ../support/thread.h)

    if (ENABLE_KDE_SUPPORT)
        kde4_add_executable(cantata-replaygain ${CANTATA_RG_SRCS} ${CANTATA_RG_MOC_SRCS})
        install(TARGETS cantata-replaygain RUNTIME DESTINATION lib/cantata)
    else (ENABLE_KDE_SUPPORT)
        if (ENABLE_QT5)
            QT5_WRAP_CPP(CANTATA_RG_MOC_SRCS ${CANTATA_RG_MOC_HDRS})
        else (ENABLE_QT5)
            INCLUDE(${QT_USE_FILE})
            QT4_WRAP_CPP(CANTATA_RG_MOC_SRCS ${CANTATA_RG_MOC_HDRS})
        endif (ENABLE_QT5)

        if (WIN32)
            set(CMAKE_BUILD_TYPE "Release")
            ADD_EXECUTABLE(cantata-replaygain WIN32 ${CANTATA_RG_SRCS} ${CANTATA_RG_MOC_SRCS} ${CANTATA_PO})
            install(TARGETS cantata-replaygain DESTINATION ${CMAKE_INSTALL_PREFIX}/helpers)
        elseif (APPLE)
            set(CMAKE_BUILD_TYPE "Release")
            ADD_EXECUTABLE(cantata-replaygain ${CANTATA_RG_SRCS} ${CANTATA_RG_MOC_SRCS} ${CANTATA_PO})
            install(TARGETS cantata-replaygain DESTINATION ${MACOSX_BUNDLE_RESOURCES}/helpers)
        else (WIN32)
            ADD_EXECUTABLE(cantata-replaygain ${CANTATA_RG_SRCS} ${CANTATA_RG_MOC_SRCS})
            install(TARGETS cantata-replaygain RUNTIME DESTINATION lib/cantata)
        endif (WIN32)
    endif (ENABLE_KDE_SUPPORT)

    find_package(Ebur128)

    if (EBUR128_FOUND)
        message("-- Using system libebur128")
        include_directories(${EBUR128_INCLUDE_DIR})
        target_link_libraries(cantata-replaygain ${EBUR128_LIBRARY})
    else (EBUR128_FOUND)
        message("-- Using supplied libebur128")
        include_directories(${CMAKE_SOURCE_DIR}/3rdparty)
        add_subdirectory(${CMAKE_SOURCE_DIR}/3rdparty/ebur128 ${CMAKE_BINARY_DIR}/3rdparty/ebur128)
        target_link_libraries(cantata-replaygain ebur128)
    endif (EBUR128_FOUND)

    if (FFMPEG_FOUND)
        target_link_libraries(cantata-replaygain ${FFMPEG_LIBRARIES})
    endif (FFMPEG_FOUND)
    if (MPG123_FOUND)
        target_link_libraries(cantata-replaygain ${MPG123_LIBRARIES})
    endif (MPG123_FOUND)
    target_link_libraries(cantata-replaygain ${QTCORELIBS})
    if (UNIX AND NOT APPLE)
        target_link_libraries(cantata-replaygain -lpthread)
    endif (UNIX AND NOT APPLE)
endif (FFMPEG_FOUND OR MPG123_FOUND)

=== support/CMakeLists.txt ===
set(SUPPORT_CORE_SRCS utils.cpp thread.cpp)
set(SUPPORT_CORE_MOC_HDRS thread.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${QTINCLUDES})

if (ENABLE_QT5)
    qt5_wrap_cpp(SUPPORT_CORE_MOC_SRCS ${SUPPORT_CORE_MOC_HDRS})
else (ENABLE_QT5)
    qt4_wrap_cpp(SUPPORT_CORE_MOC_SRCS ${SUPPORT_CORE_MOC_HDRS})
endif (ENABLE_QT5)

add_library(support-core STATIC ${SUPPORT_CORE_MOC_SRCS} ${SUPPORT_CORE_SRCS})
    
if (NOT ENABLE_UBUNTU)
    set(SUPPORT_SRCS icon.cpp fancytabwidget.cpp messagewidget.cpp buddylabel.cpp action.cpp actioncollection.cpp flickcharm.cpp
        configuration.cpp lineedit.cpp gtkstyle.cpp spinner.cpp messagebox.cpp inputdialog.cpp thread.cpp squeezedtextlabel.cpp
        touchproxystyle.cpp combobox.cpp)

    set(SUPPORT_MOC_HDRS fancytabwidget.h messagewidget.h inputdialog.h pagewidget.h  action.h actioncollection.h flickcharm.h)
    if (ENABLE_QT5)
        set(SUPPORT_MOC_HDRS ${SUPPORT_MOC_HDRS} combobox.h)
    endif (ENABLE_QT5)

    if (NOT WIN32 AND NOT APPLE)
        set(SUPPORT_SRCS ${SUPPORT_SRCS} windowmanager.cpp gtkproxystyle.cpp shortcuthandler.cpp)
        set(SUPPORT_MOC_HDRS ${SUPPORT_MOC_HDRS} windowmanager.h shortcuthandler.h)
        add_subdirectory(themes)
    endif (NOT WIN32 AND NOT APPLE)

    if (ENABLE_KDE_SUPPORT)
        include_directories(${KDE4_INCLUDES})
        # macro_ensure_version("4.7.0" ${KDE_VERSION} KDE_VERSION_47)
        # if (NOT KDE_VERSION_47)
            set(SUPPORT_SRCS ${SUPPORT_SRCS} kmessagewidget.cpp)
            set(SUPPORT_MOC_HDRS ${SUPPORT_MOC_HDRS} kmessagewidget.h)
        # endif (NOT KDE_VERSION_47)
        kde4_add_ui_files(SUPPORT_UI_HDRS ${SUPPORT_UIS})
        set(SUPPORT_SRCS ${SUPPORT_SRCS} dialog.cpp)
    else (ENABLE_KDE_SUPPORT)
        set(SUPPORT_SRCS ${SUPPORT_SRCS} pathrequester.cpp kmessagewidget.cpp dialog.cpp pagewidget.cpp shortcutsmodel.cpp
            shortcutssettingswidget.cpp keysequencewidget.cpp acceleratormanager.cpp proxystyle.cpp urllabel.cpp)
        set(SUPPORT_MOC_HDRS ${SUPPORT_MOC_HDRS} pathrequester.h kmessagewidget.h urllabel.h
             dialog.h shortcutsmodel.h shortcutssettingswidget.h keysequencewidget.h spinner.h acceleratormanager_private.h)
        set(SUPPORT_UIS shortcutssettingswidget.ui)
        if (ENABLE_QT5)
            if (Qt5Gui_VERSION_MAJOR LESS 5 OR Qt5Gui_VERSION_MINOR LESS 2)
                set(SUPPORT_MOC_HDRS ${SUPPORT_MOC_HDRS} lineedit.h)
            endif (Qt5Gui_VERSION_MAJOR LESS 5 OR Qt5Gui_VERSION_MINOR LESS 2)
            qt5_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
        else (ENABLE_QT5)
            set(SUPPORT_MOC_HDRS ${SUPPORT_MOC_HDRS} lineedit.h)
            qt4_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
        endif (ENABLE_QT5)
    endif  (ENABLE_KDE_SUPPORT)

    if (ENABLE_QT5)
        qt5_wrap_cpp(SUPPORT_MOC_SRCS ${SUPPORT_MOC_HDRS})
    else (ENABLE_QT5)
        qt4_wrap_cpp(SUPPORT_MOC_SRCS ${SUPPORT_MOC_HDRS})
    endif (ENABLE_QT5)

    add_library(support STATIC ${SUPPORT_MOC_SRCS} ${SUPPORT_SRCS} ${SUPPORT_UI_HDRS})

    if (X11_FOUND)
        target_link_libraries(support ${X11_LIBRARIES})
    endif (X11_FOUND)
endif (NOT ENABLE_UBUNTU)

=== windows/icons/CMakeLists.txt ===
set(OXYGEN_ICONS
32x32/places/server-database.png
32x32/places/favorites.png
32x32/places/network-server.png
32x32/places/document-multiple.png
32x32/actions/media-playback-pause.png
32x32/actions/document-open.png
32x32/actions/document-new.png
32x32/actions/folder-sync.png
32x32/actions/view-refresh.png
32x32/actions/document-edit.png
32x32/actions/list-remove.png
32x32/actions/speaker.png
32x32/actions/list-add.png
32x32/actions/document-save.png
32x32/actions/document-save-as.png
32x32/actions/dialog-close.png
32x32/actions/edit-delete.png
32x32/actions/view-media-artist.png
32x32/actions/media-skip-forward.png
32x32/actions/edit-find.png
32x32/actions/application-exit.png
32x32/actions/media-playback-start.png
32x32/actions/view-media-playlist.png
32x32/actions/dialog-ok.png
32x32/actions/dialog-cancel.png
32x32/actions/media-skip-backward.png
32x32/actions/configure.png
32x32/actions/edit-clear-list.png
32x32/actions/go-previous.png
32x32/actions/view-fullscreen.png
32x32/actions/process-stop.png
32x32/actions/edit-clear-locationbar-rtl.png
32x32/actions/edit-rename.png
32x32/actions/tools-wizard.png
32x32/actions/document-import.png
32x32/actions/go-next.png
32x32/actions/media-playback-stop.png
32x32/actions/document-export.png
32x32/actions/edit-clear-locationbar-ltr.png
32x32/status/media-playlist-shuffle.png
32x32/status/dialog-error.png
32x32/status/dialog-warning.png
32x32/status/dialog-information.png
32x32/status/object-locked.png
32x32/mimetypes/inode-directory.png
32x32/mimetypes/audio-x-generic.png
32x32/categories/preferences-system-network.png
32x32/categories/preferences-other.png
32x32/categories/applications-internet.png
32x32/devices/multimedia-player.png
32x32/devices/media-optical.png
32x32/apps/system-file-manager.png
32x32/apps/preferences-desktop-keyboard.png
64x64/status/dialog-error.png
64x64/status/dialog-warning.png
64x64/status/dialog-information.png
64x64/categories/preferences-system-network.png
64x64/categories/preferences-other.png
64x64/categories/applications-internet.png
64x64/devices/multimedia-player.png
64x64/devices/media-optical.png
64x64/apps/preferences-desktop-keyboard.png
22x22/places/server-database.png
22x22/places/favorites.png
22x22/places/network-server.png
22x22/places/document-multiple.png
22x22/actions/media-playback-pause.png
22x22/actions/document-open.png
22x22/actions/document-new.png
22x22/actions/folder-sync.png
22x22/actions/view-refresh.png
22x22/actions/document-edit.png
22x22/actions/list-remove.png
22x22/actions/speaker.png
22x22/actions/list-add.png
22x22/actions/document-save.png
22x22/actions/document-save-as.png
22x22/actions/dialog-close.png
22x22/actions/edit-delete.png
22x22/actions/view-media-artist.png
22x22/actions/media-skip-forward.png
22x22/actions/edit-find.png
22x22/actions/application-exit.png
22x22/actions/media-playback-start.png
22x22/actions/view-media-playlist.png
22x22/actions/dialog-ok.png
22x22/actions/dialog-cancel.png
22x22/actions/media-skip-backward.png
22x22/actions/configure.png
22x22/actions/edit-clear-list.png
22x22/actions/go-previous.png
22x22/actions/view-fullscreen.png
22x22/actions/process-stop.png
22x22/actions/edit-clear-locationbar-rtl.png
22x22/actions/edit-rename.png
22x22/actions/tools-wizard.png
22x22/actions/document-import.png
22x22/actions/go-next.png
22x22/actions/media-playback-stop.png
22x22/actions/document-export.png
22x22/actions/edit-clear-locationbar-ltr.png
22x22/status/media-playlist-shuffle.png
22x22/status/dialog-error.png
22x22/status/dialog-warning.png
22x22/status/dialog-information.png
22x22/status/object-locked.png
22x22/mimetypes/inode-directory.png
22x22/mimetypes/audio-x-generic.png
22x22/categories/preferences-system-network.png
22x22/categories/preferences-other.png
22x22/categories/applications-internet.png
22x22/devices/multimedia-player.png
22x22/devices/media-optical.png
22x22/apps/system-file-manager.png
22x22/apps/preferences-desktop-keyboard.png
16x16/places/server-database.png
16x16/places/favorites.png
16x16/places/network-server.png
16x16/places/document-multiple.png
16x16/actions/media-playback-pause.png
16x16/actions/document-open.png
16x16/actions/document-new.png
16x16/actions/folder-sync.png
16x16/actions/view-refresh.png
16x16/actions/document-edit.png
16x16/actions/list-remove.png
16x16/actions/speaker.png
16x16/actions/list-add.png
16x16/actions/document-save.png
16x16/actions/document-save-as.png
16x16/actions/dialog-close.png
16x16/actions/edit-delete.png
16x16/actions/view-media-artist.png
16x16/actions/media-skip-forward.png
16x16/actions/edit-find.png
16x16/actions/application-exit.png
16x16/actions/media-playback-start.png
16x16/actions/view-media-playlist.png
16x16/actions/dialog-ok.png
16x16/actions/dialog-cancel.png
16x16/actions/media-skip-backward.png
16x16/actions/configure.png
16x16/actions/edit-clear-list.png
16x16/actions/go-previous.png
16x16/actions/view-fullscreen.png
16x16/actions/process-stop.png
16x16/actions/edit-clear-locationbar-rtl.png
16x16/actions/edit-rename.png
16x16/actions/tools-wizard.png
16x16/actions/document-import.png
16x16/actions/go-next.png
16x16/actions/media-playback-stop.png
16x16/actions/document-export.png
16x16/actions/edit-clear-locationbar-ltr.png
16x16/status/media-playlist-shuffle.png
16x16/status/dialog-error.png
16x16/status/dialog-warning.png
16x16/status/dialog-information.png
16x16/status/object-locked.png
16x16/mimetypes/inode-directory.png
16x16/mimetypes/audio-x-generic.png
16x16/categories/preferences-system-network.png
16x16/categories/preferences-other.png
16x16/categories/applications-internet.png
16x16/devices/multimedia-player.png
16x16/devices/media-optical.png
16x16/apps/system-file-manager.png
16x16/apps/preferences-desktop-keyboard.png
48x48/actions/view-fullscreen.png
48x48/status/media-playlist-shuffle.png
48x48/status/dialog-error.png
48x48/status/dialog-warning.png
48x48/status/dialog-information.png
48x48/status/object-locked.png
48x48/categories/preferences-system-network.png
48x48/categories/preferences-other.png
48x48/categories/applications-internet.png
48x48/devices/multimedia-player.png
48x48/devices/media-optical.png
48x48/apps/preferences-desktop-keyboard.png
128x128/categories/applications-internet.png
128x128/devices/media-optical.png
256x256/categories/applications-internet.png
256x256/devices/media-optical.png
16x16/places/bookmarks.png
16x16/actions/bookmark-new.png
32x32/places/bookmarks.png
32x32/actions/bookmark-new.png
48x48/places/bookmarks.png
48x48/actions/bookmark-new.png
22x22/places/bookmarks.png
22x22/actions/bookmark-new.png
22x22/actions/bookmarks.png
64x64/places/bookmarks.png
64x64/actions/bookmark-new.png
32x32/actions/go-up.png
22x22/actions/go-up.png
16x16/actions/go-up.png
32x32/actions/go-down.png
22x22/actions/go-down.png
16x16/actions/go-down.png
)

foreach(ICON ${OXYGEN_ICONS})
    get_filename_component(ICON_PATH ${ICON} PATH)
    install(FILES ${CANTATA_OXYGEN_DIR}/${ICON} DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/${ICON_PATH})
endforeach(ICON ${OXYGEN_ICONS})
install(FILES index.theme DESTINATION ${CANTATA_ICON_INSTALL_PREFIX})
install(FILES "LICENSE.Creative Common Attribution-ShareAlike 3.0 License.html" DESTINATION ${CANTATA_ICON_INSTALL_PREFIX} RENAME "Oxygen License (Creative Common Attribution-ShareAlike 3.0).html")
install(FILES LICENSE.LGPL_V3 DESTINATION ${CANTATA_ICON_INSTALL_PREFIX} RENAME "Oxygen License (LGPL V3).txt")
install(FILES README DESTINATION ${CANTATA_ICON_INSTALL_PREFIX} RENAME "Oxygen README.txt")

=== debian/changelog ===
cantata (1.4.2.ds1-1ubuntu2) wily; urgency=medium

  * No-change rebuild against libmusicbrainz5-2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 14 Aug 2015 18:38:08 +0000

cantata (1.4.2.ds1-1ubuntu1) vivid; urgency=medium

  * Remove install dep on kde-style-oxygen which no longer exists

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 18 Dec 2014 14:34:02 +0100

cantata (1.4.2.ds1-1build1) vivid; urgency=medium

  * Rebuild against libmusicbrainz5-1.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 04 Dec 2014 11:57:11 +0000

cantata (1.4.2.ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Stuart Prescott <stuart@debian.org>  Mon, 29 Sep 2014 20:54:08 +1000

cantata (1.4.1.ds1-1) unstable; urgency=medium

  * New upstream release
    - build with system libebur128 (Closes: #739715).
    - add patch to correctly find system libebur128.
    - update copyright information.
  * Add watch file that flags new versions but cannot download new tarballs.

 -- Stuart Prescott <stuart@debian.org>  Sun, 07 Sep 2014 23:05:07 +1000

=== debian/control ===
Source: cantata
Section: sound
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Stuart Prescott <stuart@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               graphicsmagick,
               kdelibs5-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libcdparanoia-dev,
               libebur128-dev,
               libmusicbrainz5-dev,
               libmpg123-dev,
               libmtp-dev (>= 1.0.0),
               libphonon-dev,
               libqjson-dev,
               libqt4-dev,
               libqtwebkit-dev,
               libqxt-dev,
               libspeex-dev,
               libspeexdsp-dev,
               libtag-extras-dev,
               libtag1-dev,
               libx11-dev,
               pkg-config,
               pkg-kde-tools
Standards-Version: 3.9.5
Homepage: https://code.google.com/p/cantata/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/cantata.git
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/cantata.git

Package: cantata
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: mpd-client
Suggests: mpd
Description: KDE client for the music player daemon (MPD)
 Cantata is a graphical front-end for the music player daemon, MPD. It provides
 many tools to view and manage the music collection including:
 .
   * library - sorted by album, artist, track, directory
   * albums with cover art
   * user defined playlists
   * dynamic playlists
   * streams, internet radio
   * lyrics
   * artist information from Wikipedia
   * device support for USB mass storage, MTP and CDs
